-- =============================================
-- SaveToDB Framework for Microsoft SQL Server
-- Version 8.15, November 7, 2018
--
-- Copyright 2011-2018 Gartle Technology Corporation
-- =============================================

IF OBJECT_ID('[xls].[queries]', 'V') IS NOT NULL
DROP VIEW [xls].[queries];
GO

IF OBJECT_ID('[xls].[formats]', 'U') IS NOT NULL
DROP TABLE [xls].[formats];
GO
IF OBJECT_ID('[xls].[handlers]', 'U') IS NOT NULL
DROP TABLE [xls].[handlers];
GO
IF OBJECT_ID('[xls].[objects]', 'U') IS NOT NULL
DROP TABLE [xls].[objects];
GO
IF OBJECT_ID('[xls].[translations]', 'U') IS NOT NULL
DROP TABLE [xls].[translations];
GO
IF OBJECT_ID('[xls].[workbooks]', 'U') IS NOT NULL
DROP TABLE [xls].[workbooks];
GO

DECLARE @sql nvarchar(max) = ''

SELECT
    @sql = @sql + 'ALTER ROLE ' + QUOTENAME(r.name) + ' DROP MEMBER ' + QUOTENAME(m.name) + ';' + CHAR(13) + CHAR(10)
FROM
    sys.database_role_members rm
    INNER JOIN sys.database_principals r ON r.principal_id = rm.role_principal_id
    INNER JOIN sys.database_principals m ON m.principal_id = rm.member_principal_id
WHERE
    r.name IN ('xls_developers', 'xls_users')

IF LEN(@sql) > 1 
    BEGIN
    EXEC (@sql);
    PRINT @sql
    END
GO

IF DATABASE_PRINCIPAL_ID('xls_developers') IS NOT NULL
DROP ROLE [xls_developers];
GO
IF DATABASE_PRINCIPAL_ID('xls_formats') IS NOT NULL
DROP ROLE [xls_formats];
GO
IF DATABASE_PRINCIPAL_ID('xls_users') IS NOT NULL
DROP ROLE [xls_users];
GO

IF SCHEMA_ID('xls') IS NOT NULL
DROP SCHEMA [xls];
GO

print 'SaveToDB Framework removed';
